[![Build Status](https://travis-ci.org/wesovilabs/beyond.svg?branch=master)](https://travis-ci.org/wesovilabs/beyond)
[![Go Report Card](https://goreportcard.com/badge/github.com/wesovilabs/beyond)](https://goreportcard.com/report/github.com/wesovilabs/beyond)
[![GoDoc](https://godoc.org/github.com/wesovilabs/beyond?status.svg)](https://godoc.org/github.com/wesovilabs/beyond)
[![codecov](https://codecov.io/gh/wesovilabs/beyond/branch/master/graph/badge.svg)](https://codecov.io/gh/wesovilabs/beyond)
[![Mentioned in Awesome Go](https://awesome.re/mentioned-badge-flat.svg)](https://github.com/avelino/awesome-go)

# Beyond

The Golang library that will drive you to the AOP paradigm world!

Check [Beyond Documentation](http://wesovilabs.github.io/beyond)

## What's AOP?

> In computing, aspect-oriented programming (AOP) is a programming paradigm that aims to increase modularity by allowing the separation of cross-cutting concerns. It does so by adding additional behavior to existing code (an advice) without modifying the code itself, instead separately specifying which code is modified via a "pointcut" specification

* Extracted  from [Wikipedia](https://en.wikipedia.org/wiki/Aspect-oriented_programming) 

# Getting Started

## Install beyond
```bash
go get -u github.com/wesovilabs/beyond
```

## Add beyond to your project 

Add beyond to go.mod. 

**go.mod**

```text
module github.com/myrepository/myapp
...
require github.com/wesovilabs/beyond v0.0.1
...
```

# Documentation

Beyond Documentation is published at [http://wesovilabs.github.io/beyond](http://wesovilabs.github.io/beyond)

## Versioning
    
We use [SemVer](http://semver.org/) for versioning. For the versions available, see the [tags on this repository](https://github.com/wesovilabs/beyond/tags).

# Authors

- **Iván Corrales Solera <ivan.corrales.solera@gmail.com>** 

See also the list of [contributors](https://github.com/wesovilabs/beyond/contributors) who participated in this project.


# License

This project is licensed under the MIT License - see the [LICENSE.md](LICENSE.md) file for details

